unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ImgList, Frame1Unit, StdCtrls, OleServer,
  MSXML2_TLB, ComCtrls,TypeUnit,math;

type
  TForm1 = class(TForm)
    Frame11: TFrame1;
    MainMenu1: TMainMenu;
    ImageList1: TImageList;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    OpenDialog1: TOpenDialog;
    TreeView1: TTreeView;
    Frame12: TFrame1;
    ListBox1: TListBox;
    ListBox2: TListBox;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    CheckBox2: TCheckBox;
    ComboBox1: TComboBox;
    Label4: TLabel;
    procedure Exit1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure MapDraw;
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure ListBox2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    xmldoc:IXMLDocument2;
    xmldocroot:IXMLElement2;
    xmldomdoc:IXMLDOMDocument2;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses Types, Contnrs;

{$R *.dfm}

procedure TForm1.Exit1Click(Sender: TObject);
begin
  Close();
end;

procedure EnumXML(parnt:TTreeNode;xmlnodelist:IXMLDOMNodeList);
var xmlnode:IXMLDOMNode;
    it:TTreeNode;
    mnodelist:IXMLDOMNodeList;
    mnode:IXMLDOMNode;
    mname,mx,my:string;
    cz,cdo,cvzd,cspd:String;
    sspd,sltr:string;
begin
//  Form1.TreeView1.Items.AddChild
  it:=nil;
  xmlnodelist.reset;
  xmlnode:=xmlnodelist.nextNode;
  while assigned(xmlnode) do begin
    if (xmlnode.nodeName<>'#text')  then begin
      if xmlnode.nodeName='mesto' then begin
        mnodelist:=xmlnode.childNodes;
        mnodelist.reset;
        mnode:=mnodelist.nextNode;
        mname:='[nepojmenovno]';
        mx:='0';
        my:='0';
        while assigned(mnode) do begin
          if (mnode.nodeName='nazev') then mname:=mnode.firstChild.nodeValue;
          if (mnode.nodeName='polohaX') then mx:=mnode.firstChild.nodeValue;
          if (mnode.nodeName='polohaY') then my:=mnode.firstChild.nodeValue;
          mnode:=mnodelist.nextNode;
        end;
        it:=Form1.TreeView1.Items.AddChild(parnt,'{'+mname+'} ['+mx+','+my+']');
        AddTown(mname,StrToIntDef(mx,0),strtointdef(my,0));        
      end else if xmlnode.nodeName='cesta' then begin
        mnodelist:=xmlnode.childNodes;
        mnodelist.reset;
        mnode:=mnodelist.nextNode;
        cz:='[neznmo]';
        cdo:='[neznmo]';
        cvzd:='0';
        cspd:='0';
        while assigned(mnode) do begin
          if (mnode.nodeName='z') then cz:=mnode.firstChild.nodeValue;
          if (mnode.nodeName='do') then cdo:=mnode.firstChild.nodeValue;
          if (mnode.nodeName='vzdalenost') then cvzd:=mnode.firstChild.nodeValue;
          if (mnode.nodeName='prumernaRychlost') then cspd:=mnode.firstChild.nodeValue;
          mnode:=mnodelist.nextNode;
        end;
        it:=Form1.TreeView1.Items.AddChild(parnt,'{'+cz+' - '+cdo+'} ['+cvzd+'km : '+cspd+'km/h]');
        AddPath(cz,cdo,StrToIntDef(cvzd,0),strtointdef(cspd,0));
      end else if xmlnode.nodeName='spotreba' then begin
        mnodelist:=xmlnode.childNodes;
        mnodelist.reset;
        mnode:=mnodelist.nextNode;
        sspd:='0';
        sltr:='0';
        while assigned(mnode) do begin
          if (mnode.nodeName='rychlost') then sspd:=mnode.firstChild.nodeValue;
          if (mnode.nodeName='litru') then sltr:=mnode.firstChild.nodeValue;
          mnode:=mnodelist.nextNode;
        end;
        it:=Form1.TreeView1.Items.AddChild(parnt,'{'+sspd+'km/h} ['+sltr+'l]');
        AddSpeed(StrToIntDef(sspd,0),strtofloatdef(sltr,0));


      end else begin
        it:=Form1.TreeView1.Items.AddChild(parnt,'['+xmlnode.nodeName+']');
        if xmlnode.haschildNodes then begin
          EnumXML(it,xmlnode.childNodes);
        end;
      end;
    end else begin
      it:=Form1.TreeView1.Items.AddChild(parnt,xmlnode.nodeValue);
    end;
    xmlnode:=xmlnodelist.nextNode;
  end;
end;

procedure TForm1.Open1Click(Sender: TObject);
var sl:TStringList;
begin
  if OpenDialog1.Execute then begin
    ClearDocLists;

    treeview1.Items.BeginUpdate;
    treeview1.Items.Clear;
    treeview1.Items.EndUpdate;

    listbox1.Items.BeginUpdate;
    listbox1.Items.Clear;
    listbox1.Items.EndUpdate;

    listbox2.Items.BeginUpdate;
    listbox2.Items.Clear;
    listbox2.Items.EndUpdate;

    sl:=TStringList.Create;
    sl.LoadFromFile(OpenDialog1.FileName);
    xmldomdoc:=CoDOMDocument30.Create;
    xmldomdoc.loadXML(sl.Text);
    sl.Free;
//    TreeView1.Items.BeginUpdate;
    EnumXML(nil,xmldomdoc.childNodes);

    ProcessPaths;

    listbox1.Items.AddStrings(TownNameList);
//    TreeView1.Items.EndUpdate;
    MapDraw;
  end;
end;

procedure TForm1.MapDraw;
var x,y,x2,y2:integer;
    s:string;
    i:integer;
    w,h:integer;
    rw,rh:integer;
    iw,ih:integer;
    zx,zy,z:real;
    path:TCesta;
    speed:TSpotreba;
    cdng:integer;
begin
  rw:=TownRect.Right-TownRect.Left;
  rh:=TownRect.Bottom-TownRect.Top;

//  zx:=log10(rw/800)+1;
//  zy:=log10(rh/600)+1;
  zx:=rw/800;
  zy:=rh/600;
  z:=max(zx,zy);
  if z=0 then z:=1;

  w:=trunc(rw/z)+16+6*8;
  h:=trunc(rh/z)+16;

  Frame11.Image1.Width:=w;
  Frame11.Image1.height:=h;

  Frame11.Image1.Picture.Bitmap.Width:=w;
  Frame11.Image1.Picture.Bitmap.Height:=h;

  Frame11.Image1.Canvas.Brush.Color:=clwhite;
  Frame11.Image1.Canvas.FillRect(rect(0,0,w,h));

  Frame11.Image1.Canvas.pen.Color:=clBlack;
  Frame11.Image1.Canvas.pen.Width:=1;
  for i:=0 to pred(TownList.Count) do begin
    s:=(TownList.Items[i] as TMesto).jmeno;
    x:=(TownList.Items[i] as TMesto).x;
    y:=(TownList.Items[i] as TMesto).y;
    x:=trunc((x-TownRect.Left)/z)+8;
    y:=trunc((y-TownRect.Top)/z)+8;
    Frame11.Image1.Canvas.Brush.Color:=clLime;
    Frame11.Image1.Canvas.Ellipse(x-4,y-4,x+4,y+4);
    Frame11.Image1.Canvas.Brush.Color:=clwhite;
    Frame11.Image1.Canvas.TextOut(x+5,y-7,s);
  end;

  if Checkbox2.Checked then begin

  Frame11.Image1.Canvas.pen.Color:=clBlack;
  Frame11.Image1.Canvas.pen.Width:=2;
  for i:=0 to pred(PathList.Count) do begin
    path:=(PathList.Items[i] as TCesta);

    x:=path.cod.x;
    y:=path.cod.y;
    x2:=path.cdo.x;
    y2:=path.cdo.y;

    x:=trunc((x-TownRect.Left)/z)+8;
    y:=trunc((y-TownRect.Top)/z)+8;
    x2:=trunc((x2-TownRect.Left)/z)+8;
    y2:=trunc((y2-TownRect.Top)/z)+8;
  cdng:=max(min((path.rychlost-60)*4,255),0);
  Frame11.Image1.Canvas.pen.Color:=rgb(cdng,255-cdng,0);

    Frame11.Image1.Canvas.moveto(x,y);
    Frame11.Image1.Canvas.lineto(x2,y2);

  end;
  end;

  Frame11.Image1.Canvas.pen.Color:=clBlue;   //zobrazeni nalezene cesty
  Frame11.Image1.Canvas.pen.Width:=4;
  for i:=0 to pred(FoundPathList.Count) do begin
    path:=(FoundPathList.Items[i] as TCesta);

    x:=path.cod.x;
    y:=path.cod.y;
    x2:=path.cdo.x;
    y2:=path.cdo.y;

    x:=trunc((x-TownRect.Left)/z)+8;
    y:=trunc((y-TownRect.Top)/z)+8;
    x2:=trunc((x2-TownRect.Left)/z)+8;
    y2:=trunc((y2-TownRect.Top)/z)+8;

    Frame11.Image1.Canvas.moveto(x,y);
    Frame11.Image1.Canvas.lineto(x2,y2);

  end;

  iw:=87;
  ih:=(SpeedList.Count+1)*13;

  Frame12.Image1.Width:=iw;
  Frame12.Image1.height:=ih;

  Frame12.Image1.Picture.Bitmap.Width:=iw;
  Frame12.Image1.Picture.Bitmap.Height:=ih;

  Frame12.Image1.Canvas.Brush.Color:=clwhite;
  Frame12.Image1.Canvas.FillRect(rect(0,0,w,h));


  Frame12.Image1.Canvas.pen.Color:=clBlack;
  Frame12.Image1.Canvas.pen.Width:=2;
  for i:=0 to pred(SpeedList.Count) do begin
    speed:=(SpeedList.Items[i] as TSpotreba);

    x:=0;
    y:=i*13;
    x2:=x+30;
    y2:=y;
  x:=x+2;
  y:=y+7;
  x2:=x2+2;
  y2:=y2+7;
  cdng:=max(min((speed.rychlost-60)*4,255),0);
  Frame12.Image1.Canvas.pen.Color:=rgb(cdng,255-cdng,0);

    Frame12.Image1.Canvas.moveto(x,y);
    Frame12.Image1.Canvas.lineto(x2,y2);
    Frame12.Image1.Canvas.TextOut(x2+5,y2-7,inttostr(speed.rychlost)+' km/h');    
  end;


  i:=SpeedList.Count;
    x:=0;
    y:=i*13;
    x2:=x+30;
    y2:=y;
  x:=x+2;
  y:=y+7;
  x2:=x2+2;
  y2:=y2+7;
  Frame12.Image1.Canvas.pen.Width:=4;
  Frame12.Image1.Canvas.pen.Color:=clBlue;

    Frame12.Image1.Canvas.moveto(x,y);
    Frame12.Image1.Canvas.lineto(x2,y2);
    Frame12.Image1.Canvas.TextOut(x2+5,y2-7,'Nlez');
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
var i:integer;
    s1,s2:string;
begin
  listbox2.Items.BeginUpdate;
  listbox2.Items.Clear;
  if Checkbox1.Checked then begin

    listbox2.Items.AddStrings((listbox1.items.Objects[listbox1.ItemIndex] as TMesto).PathList);

    for i:=0 to pred(listbox2.Items.Count) do begin
      s1:=inttostr(((listbox2.Items.objects[i] as TCesta).vzdalenost));
      s2:=TimeToStr(((listbox2.Items.objects[i] as TCesta).cas_sec / (60*60*24)));
      listbox2.Items[i]:=listbox2.Items[i]+' ['+s1+'km za '+s2+']';
    end;
  end else begin
    listbox2.Items.AddStrings(TownnameList);
  end;
  listbox2.Items.EndUpdate;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  MapDraw;
end;

procedure TForm1.ListBox2Click(Sender: TObject);
var zt,dot:TMesto;
    pth:TCesta;
begin
  FoundPathList.Clear;
  zt:=listbox1.items.objects[listbox1.ItemIndex] as TMesto;
  if checkbox1.checked then begin
    pth:=(listbox2.items.objects[listbox2.ItemIndex] as TCesta);
    if pth.cod=zt then dot:=pth.cdo else dot:=pth.cod;
    FoundPathList.add(pth);
  end else begin
    dot:=listbox2.items.objects[listbox2.ItemIndex] as Tmesto;
  end;
  caption:='Cesta z msta: '+zt.jmeno+' do: '+dot.jmeno;
  MapDraw;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  combobox1.ItemIndex:=0;
end;

end.
